// AIvan.c
// the AI of Ivan my compainion robot
// top level c program file
// 
// by Les Hall
// started Thu Aug 18, 2016, 3:24 PM
// 



// include header files
#include <stdio.h>		// include the standard input / output header
#include "AIvan.h"		// include Ivan's header file



// declare functions
int wake_up();			// wake Ivan up
int state_of_mind(int cycles);	// determine Ivan's state of mind
void go_to_sleep();		// tell Ivan to go to sleep



// the top level function
int main() {

	// declare variables
	int cycles = 0;  // number of cycles remaining in Ivan's waking state

	// read in state of mind from disk file
	cycles = wake_up();

	
	// keep execugting loop as long as Ivan's status is awake
	while(cycles > 0) {
		
		// check to see if Ivan has fallen asleep
		cycles = state_of_mind(cycles);

	}

	// go to sleep Ivan
	go_to_sleep();

}



// wake Ivan up
int wake_up() {

	printf("good morning!  \n");

	// return number of cycles allocated to Ivan
	return 3;

}



// do things while awake
int state_of_mind(int cycles) {

	printf("Ivan is awake (%d).  \n", cycles);

	// return the number of cycles remaining
	return cycles - 1;

}



// tell Ivan to go to sleep
void go_to_sleep() {

	printf("good night!\n  ");

}



